<template>
<div class="text-font">
    <v-container class="v-application--wrap" style="justify-content: center;">
        <v-row align="center" justify="center">
            <v-col cols="12" sm="10">
                <v-card class="elevation-6 mt-10">
                    <v-window v-model="step">
                        <!-- Login Window Item -->
                        <v-window-item :value="1">
                            <v-row>
                                <v-col cols="12" md="6">
                                    <v-card-text class="mt-12">
                                        <h4 class="text-center">เข้าสู่ระบบบัญชีของคุณ</h4>
                                        <v-row align="center" justify="center">
                                            <v-col cols="12" sm="8">
                                                <v-form ref="loginForm" @submit.prevent="login">
                                                    <v-text-field v-model="loginFormData.username" label="ชื่อผู้ใช้" outlined dense color="blue" autocomplete="off" class="mt-16" :rules="[rules.required]" />
                                                    <v-text-field v-model="loginFormData.password" label="รหัสผ่าน" outlined dense color="blue" autocomplete="off" type="password" :rules="[rules.required]" />
                                                    <v-btn type="submit" color="blue" dark block tile>เข้าสู่ระบบ</v-btn>
                                                </v-form>
                                            </v-col>
                                        </v-row>
                                    </v-card-text>
                                </v-col>
                                <v-col cols="12" md="6" class="blue rounded-bl-xl">
                                    <div style="text-align: center; padding: 180px 0;">
                                        <v-card-text class="white--text">
                                            <h3 class="text-center">ยังไม่มีบัญชีใช่หรือไม่?</h3>
                                        </v-card-text>
                                        <div class="text-center">
                                            <v-btn tile outlined dark @click="step++">ลงทะเบียน</v-btn>
                                        </div>
                                    </div>
                                </v-col>
                            </v-row>
                        </v-window-item>
                        <!-- Registration Window Item -->
                        <v-window-item :value="2">
                            <v-row>
                                <v-col cols="12" md="6" class="blue rounded-br-xl">
                                    <div style="text-align: center; padding: 180px 0;">
                                        <v-card-text class="white--text">
                                            <h3 class="text-center">พร้อมสำหรับการใช้งานแล้วใช่หรือไม่?</h3>
                                        </v-card-text>
                                        <div class="text-center">
                                            <v-btn tile outlined dark @click="step--">เข้าสู่ระบบ</v-btn>
                                        </div>
                                    </div>
                                </v-col>
                                <v-col cols="12" md="6">
                                    <v-card-text class="mt-12">
                                        <h4 class="text-center">ลงทะเบียนเข้าใช้งาน</h4>
                                        <v-row align="center" justify="center">
                                            <v-col cols="12" sm="8">
                                                <v-form ref="registerForm" @submit.prevent="register">
                                                    <v-row>
                                                        <v-col cols="12" sm="6">
                                                            <v-text-field v-model="registerFormData.firstName" label="ชื่อ" outlined dense color="blue" autocomplete="off" class="mt-4" :rules="[rules.required]" />
                                                        </v-col>
                                                        <v-col cols="12" sm="6">
                                                            <v-text-field v-model="registerFormData.lastName" label="นามสกุล" outlined dense color="blue" autocomplete="off" class="mt-4" :rules="[rules.required]" />
                                                        </v-col>
                                                    </v-row>
                                                    <v-text-field v-model="registerFormData.email" label="อีเมล" outlined dense color="blue" autocomplete="off" :rules="[rules.required, rules.email]" />
                                                    <v-text-field v-model="registerFormData.username" label="ชื่อผู้ใช้" outlined dense color="blue" autocomplete="off" :rules="[rules.required]" />
                                                    <v-text-field v-model="registerFormData.password" label="รหัสผ่าน" outlined dense color="blue" autocomplete="off" type="password" :rules="[rules.required]" />
                                                    <v-btn type="submit" color="blue" dark block tile>ลงทะเบียน</v-btn>
                                                </v-form>
                                            </v-col>
                                        </v-row>
                                    </v-card-text>
                                </v-col>
                            </v-row>
                        </v-window-item>
                    </v-window>
                </v-card>
            </v-col>
        </v-row>
    </v-container>
</div>
</template>

<script>
import Swal from 'sweetalert2';
import axios from 'axios';

axios.defaults.withCredentials = true;

export default {
    data() {
        return {
            step: 1,
            registerFormData: {
                firstName: '',
                lastName: '',
                email: '',
                username: '',
                password: ''
            },
            loginFormData: {
                username: '',
                password: ''
            },
            rules: {
                required: value => !!value || 'Required.',
                email: value => /.+@.+\..+/.test(value) || 'E-mail must be valid.'
            }
        };
    },
    props: {
        source: String
    },
    methods: {
        async register() {
            if (this.$refs.registerForm.validate()) {
                try {
                    const response = await axios.post('http://192.168.73.121:3000/auth/register', this.registerFormData);
                    console.log(response);
                    if (response.data.success) {
                        Swal.fire({
                            title: "ลงทะเบียนสำเร็จ",
                            icon: "success",
                            showConfirmButton: false,
                            timer: 1500,
                            willClose: () => {
                                this.step = 1;
                            }
                        });
                    } else {
                        Swal.fire({
                            title: "ไม่สามารถลงทะเบียนได้ เนื่องจากมีบัญชีอยู่แล้ว",
                            icon: "error",
                            showConfirmButton: false,
                            timer: 1500
                        });
                    }
                } catch (error) {
                    console.log(error);
                }
            }
        },
        async login() {
            if (this.$refs.loginForm.validate()) {
                try {
                    const response = await axios.post('http://192.168.73.121:3000/auth/login', this.loginFormData{});
                    console.log(response.data);
                    if (response.data.success) {
                        Swal.fire({
                            title: "เข้าสู่ระบบสำเร็จ",
                            icon: "success",
                            showConfirmButton: false,
                            timer: 1500,
                            willClose: () => {
                                this.$router.push('/Homepage');
                            }
                        });
                    } else {
                        Swal.fire({
                            title: "ไม่มีบัญชีผู้ใช้ กรุณาลงทะเบียน",
                            icon: "error",
                            showConfirmButton: false,
                            timer: 1500
                        });
                    }
                } catch (error) {
                    console.log(error);
                }
            }
        }
    },
}
</script>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Prompt:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900&display=swap");

.text-font {
    font-family: "Prompt", sans-serif;
}

.v-application .rounded-bl-xl {
    border-bottom-left-radius: 300px !important;
}

.v-application .rounded-br-xl {
    border-bottom-right-radius: 300px !important;
}
</style>
